|##########|
|#MAGIC   #|BOPDNEAC
|#PROJECT #|""
|#PATHS   #|"Project2.0"
|#FLAGS   #|xx---x--x---x-x-----------------
|#USERSW  #|--------------------------------
|#USERMASK#|--------------------------------
|#SWITCHES#|x--x-x----------
|##########|
IMPLEMENTATION MODULE ODictionaries;

FROM Resources IMPORT New,Dispose,Create_Context,Delete_Context,Allocate;
FROM Str       IMPORT Equal;
FROM System    IMPORT Regs;

  IMPLEMENTATION MODULE TextDicts;

    TYPE
      DictNode = POINTER TO DicEntry;
      HashTab  = CLASSPTR TO ARRAY OF DictNode;
      DicEntry = RECORD
                   next : DictNode;
                   name : POINTER TO STRING;
                   data : ElemType;
                 END;

      DictData = POINTER TO RECORD
                   entries : LONGINT;
                   hash    : HashTab;
                 END;

    $$EntryCode:=FALSE
    PROCEDURE Hash(REF s IN A0 : STRING):CARDINAL;
    BEGIN
      ASSEMBLE(USE     D0/D1
               MOVE.W  #$AAAA,D1
               MOVE.W  (A0)+,D0
      loop:    ROL.W   #1,D0
               ROL.W   #2,D1
               MOVE.B  (A0)+,D1
               BEQ     exit
               ADD.W   D1,D0
               BRA     loop
      exit:    RTS);
    END Hash;

    METHOD Dictionary.Create(context : ContextPtr);
    BEGIN
      Resources.ChangeObjContext(SELF,context);
      con:=Create_Context(context);
      New(data,context:=context);
      data.entries:=0;
      data.hash'RANGE:=16;
      New(data.hash,clear:=TRUE,context:=context);
    END Create;

    METHOD Dictionary.Delete;
    BEGIN
    END Delete;

    METHOD Dictionary.Add(REF s : STRING;elem : ElemType);
    VAR h   : HashTab;
        i   : INTEGER;
        q,r : DictNode;
        c   : CARDINAL;
    BEGIN
      INC(data.entries);
      IF (data.hash'RANGE<16384) AND (data.entries DIV 4>=data.hash'RANGE) THEN
        h'RANGE:=data.hash'RANGE*2;
        New(h,clear:=TRUE,context:=con);
        FOR i:=0 TO data.hash'MAX DO
          q:=data.hash[i];
          WHILE q#NIL DO
            r:=q.next;
            $$RangeChk:=FALSE
            c:=Hash(q.name^) MOD CARDINAL(h'RANGE);
            $$RangeChk:=OLD
            q.next:=h[c];h[c]:=q;
            q:=r;
          END;
        END;
        Dispose(data.hash);
        data.hash:=h;
      END;
      c:=Hash(s) MOD CARDINAL(data.hash'RANGE);
      q:=data.hash[c];
      $$RangeChk:=FALSE
      WHILE (q#NIL) AND NOT Equal(s,q.name^) DO q:=q.next END;
      $$RangeChk:=OLD
      ASSERT2(q=NIL,SymbolExists);
      New(q,context:=con);
      Allocate(q.name,s.len+4,context:=con);
      q.next:=data.hash[c];
      data.hash[c]:=q;
      $$RangeChk:=FALSE
      q.name^:=s;
      $$RangeChk:=OLD
      q.data:=elem;
    END Add;

    METHOD Dictionary.Rem(REF s : STRING);
    VAR q,r  : DictNode;
        c    : CARDINAL;
        i    : INTEGER;
        h    : HashTab;
    BEGIN
      c:=Hash(s) MOD CARDINAL(data.hash'RANGE);
      r:=NIL;
      q:=data.hash[c];
      $$RangeChk:=FALSE
      WHILE (q#NIL) AND NOT Equal(s,q.name^) DO r:=q;q:=q.next END;
      $$RangeChk:=OLD
      ASSERT2(q#NIL,SymbolNotFound);
      IF r=NIL THEN
        data.hash[c]:=q.next
      ELSE
        r.next:=q.next
      END;
      Dispose(q.name);
      Dispose(q);
      DEC(data.entries);
      (*
      IF (data.hash'RANGE>32) AND (data.entries<=data.hash'RANGE) THEN
        h'RANGE:=data.hash'RANGE DIV 2;
        New(h,clear:=TRUE,context:=con);
        FOR i:=0 TO data.hash'MAX DO
          q:=data.hash[i];
          WHILE q#NIL DO
            r:=q.next;
            $$RangeChk:=FALSE
            c:=Hash(q.name^) MOD CARDINAL(h'RANGE);
            $$RangeChk:=OLD
            q.next:=h[c];h[c]:=q;
            q:=r;
          END;
        END;
        Dispose(data.hash);
        data.hash:=h;
      END;
      *)
    END Rem;

    METHOD Dictionary.RemElem(elem : ElemType);
    VAR q,r  : DictNode;
        i    : INTEGER;
        h    : HashTab;
        c    : CARDINAL;
    BEGIN
      i:=data.hash'MAX;
      REPEAT
        r:=NIL;
        q:=data.hash[i];
        WHILE (q#NIL) AND (q.data#elem) DO r:=q;q:=q.next END;
        DEC(i);
      UNTIL (q#NIL) OR (i<0);
      ASSERT2(q#NIL,SymbolNotFound);
      IF r=NIL THEN
        data.hash[i]:=q.next
      ELSE
        r.next:=q.next
      END;
      Dispose(q.name);
      Dispose(q);
      DEC(data.entries);
      IF (data.hash'RANGE>32) AND (data.entries<=data.hash'RANGE) THEN
        h'RANGE:=data.hash'RANGE DIV 2;
        New(h,clear:=TRUE,context:=con);
        FOR i:=0 TO data.hash'MAX DO
          q:=data.hash[i];
          WHILE q#NIL DO
            r:=q.next;
            $$RangeChk:=FALSE
            c:=Hash(q.name^) MOD CARDINAL(h'RANGE);
            $$RangeChk:=OLD
            q.next:=h[c];h[c]:=q;
            q:=r;
          END;
        END;
        Dispose(data.hash);
        data.hash:=h;
      END;
    END RemElem;

    METHOD Dictionary.Search(REF s : STRING):ElemType;
    VAR q : DictNode;
    BEGIN
      q:=data.hash[Hash(s) MOD CARDINAL(data.hash'RANGE)];
      $$RangeChk:=FALSE
      WHILE (q#NIL) AND NOT Equal(s,q.name^) DO q:=q.next END;
      $$RangeChk:=OLD
      ASSERT2(q#NIL,SymbolNotFound);
      RETURN q.data;
    END Search;

    METHOD Dictionary.Exists(REF s : STRING):BOOLEAN;
    VAR q : DictNode;
    BEGIN
      q:=data.hash[Hash(s) MOD CARDINAL(data.hash'RANGE)];
      $$RangeChk:=FALSE
      WHILE (q#NIL) AND NOT Equal(s,q.name^) DO q:=q.next END;
      $$RangeChk:=OLD
      RETURN q#NIL;
    END Exists;

    METHOD Dictionary.Change(REF s : STRING;elem : ElemType);
    VAR q : DictNode;
    BEGIN
      q:=data.hash[Hash(s) MOD CARDINAL(data.hash'RANGE)];
      $$RangeChk:=FALSE
      WHILE (q#NIL) AND NOT Equal(s,q.name^) DO q:=q.next END;
      $$RangeChk:=OLD
      ASSERT2(q#NIL,SymbolNotFound);
      q.data:=elem;
    END Change;

    METHOD Dictionary.Apply(apply : ApplyProc);
    VAR q,p : DictNode;
        i : INTEGER;
    BEGIN
      FOR i:=0 TO data.hash'MAX DO
        q:=data.hash[i];
        WHILE q#NIL DO
          p:=q.next;
          $$RangeChk:=FALSE
          apply(q.name^,q.data);
          $$RangeChk:=OLD
          q:=p;
        END;
      END;
    END Apply;

    METHOD Dictionary.Destruct;
    BEGIN
      Delete_Context(con);
    END Destruct;

  END TextDicts;

END ODictionaries.
