|##########|
|#MAGIC   #|BOPDNEAH
|#PROJECT #|""
|#PATHS   #|"Project2.0"
|#FLAGS   #|xx---x--x---x-x-----------------
|#USERSW  #|--------------------------------
|#USERMASK#|--------------------------------
|#SWITCHES#|x----x----------
|##########|
IMPLEMENTATION MODULE OLists;

  IMPLEMENTATION MODULE BiLists;

    METHOD Node.Delete;BEGIN END Delete;
    METHOD Node.Clone():Node;BEGIN END Clone;

    METHOD List.InsertFirst(n : Node);
    BEGIN
      IF first#NIL THEN
        first.prev:=n;
      ELSE
        last:=n
      END;
      n.prev:=NIL;
      n.next:=first;
      first:=n;
    END InsertFirst;

    METHOD List.InsertLast(n : Node);
    BEGIN
      IF last#NIL THEN
        last.next:=n
      ELSE
        first:=n
      END;
      n.next:=NIL;
      n.prev:=last;
      last:=n;
    END InsertLast;

    METHOD List.InsertAfter(n,after : Node);
    BEGIN
      n.prev:=after;
      n.next:=after.next;
      IF after.next#NIL THEN
        after.next.prev:=n
      ELSE
        last:=n
      END;
      after.next:=n
    END InsertAfter;

    METHOD List.InsertBefore(n,before : Node);
    BEGIN
      n.next:=before;
      n.prev:=before.prev;
      IF before.prev#NIL THEN
        before.prev.next:=n
      ELSE
        first:=n
      END;
      before.prev:=n;
    END InsertBefore;


    METHOD List.RemoveNode(n : Node);
    BEGIN
      IF n.prev#NIL THEN
        n.prev.next:=n.next
      ELSE
        first:=n.next
      END;
      IF n.next#NIL THEN
        n.next.prev:=n.prev
      ELSE
        last:=n.prev
      END;
    END RemoveNode;

    METHOD List.DeleteNode(n : Node);
    BEGIN
      IF n.prev#NIL THEN
        n.prev.next:=n.next
      ELSE
        first:=n.next
      END;
      IF n.next#NIL THEN
        n.next.prev:=n.prev
      ELSE
        last:=n.prev
      END;
      n.Delete;
    END DeleteNode;


    METHOD List.RemoveAll;
    BEGIN
      first:=NIL;
      last:=NIL
    END RemoveAll;

    METHOD List.DeleteAll;
    VAR n,m : Node;
    BEGIN
      n:=first;
      WHILE n#NIL DO m:=n;n:=n.next;m.Delete END;
      first:=NIL;
      last:=NIL;
    END DeleteAll;


    METHOD List.RemoveIF(if : Condition);
    VAR n,m : Node;
    BEGIN
      n:=first;
      WHILE n#NIL DO
        m:=n;n:=n.next;
        IF if(m) THEN SELF.RemoveNode(m) END;
      END;
    END RemoveIF;

    METHOD List.DeleteIF(if : Condition);
    VAR n,m : Node;
    BEGIN
      n:=first;
      WHILE n#NIL DO
        m:=n;n:=n.next;
        IF if(m) THEN SELF.DeleteNode(m) END;
      END;
    END DeleteIF;

    METHOD List.Sort;
    BEGIN
    END Sort;

    METHOD List.Apply(app : ApplyProc);
    VAR n : Node;
    BEGIN
      n:=first;
      WHILE n#NIL DO app(n);n:=n.next END;
    END Apply;

    METHOD List.ApplyIF(app : ApplyProc;if : Condition);
    VAR n : Node;
    BEGIN
      n:=first;
      WHILE n#NIL DO
        IF if(n) THEN app(n) END;
        n:=n.next
      END;
    END ApplyIF;

    METHOD List.Find(if : Condition;from : Node):Node;
    BEGIN
      IF from#NIL THEN
        from:=from.next
      ELSE
        from:=first
      END;
      WHILE (from#NIL) AND NOT if(from) DO from:=from.next END;
      RETURN from;
    END Find;

    METHOD List.Clone():List;
    VAR l : List;
        n : Node;
    BEGIN
      l:=CLONE(SELF);
      l.first:=NIL;l.last:=NIL;
      n:=first;
      WHILE n#NIL DO
        l.InsertLast(n.Clone());
        n:=n.next
      END;
      RETURN l;
    END Clone;

    METHOD List.Append(VAR l : List);
    VAR n : Node;
    BEGIN
      n:=l.first;
      WHILE n#NIL DO
        SELF.InsertLast(n);
        n:=n.next;
      END;
      l.RemoveAll;
      DISPOSE(l);
      l:=NIL;
    END Append;

    METHOD List.Destruct;
    BEGIN
      |SELF.DeleteAll;
    END Destruct;

    METHOD List.Create(nodes : LIST OF Node);
    VAR i : INTEGER;
    BEGIN
      FOR i:=0 TO nodes'MAX DO
        SELF.InsertLast(nodes[i]);
      END;
    END Create;

    METHOD List.Delete;BEGIN END Delete;

  END BiLists;

END OLists.

